# palette

[![Crates.io](https://img.shields.io/crates/v/palette.svg)](https://crates.io/crates/palette/)
[![Docs.rs](https://docs.rs/palette/badge.svg)](https://docs.rs/palette)

A color management and conversion library that focuses on maintaining correctness, flexibility and ease of use. It makes use of the type system to prevent mistakes, support a wide range of color spaces including user defined variants and offer different ways of integrating with other libraries.

[Usage and examples can be found in the `palette` directory](https://github.com/Ogeon/palette/tree/master/palette).

## Online Documentation

[Released](https://docs.rs/palette/0.7.3/palette/)

[Master branch](https://ogeon.github.io/palette/palette/index.html)

## Minimum Supported Rust Version (MSRV)

This version of Palette has been automatically tested with Rust version `1.60.0` and the `stable`, `beta`, and `nightly` channels. Future versions of the library may advance the minimum supported version to make use of new language features, but this will normally be considered a breaking change. Exceptions may be made for security patches and similar changes.

## Contributing

All sorts of contributions are welcome (<strike>including</strike> especially speling corrections), so take a look at [CONTRIBUTING.md](CONTRIBUTING.md) for guidelines, if you are interested.

## License

Licensed under either of

* Apache License, Version 2.0, ([LICENSE-APACHE](LICENSE-APACHE) or <http://www.apache.org/licenses/LICENSE-2.0>)
* MIT license ([LICENSE-MIT](LICENSE-MIT) or <http://opensource.org/licenses/MIT>)

at your option.

Unless you explicitly state otherwise, any contribution intentionally submitted for inclusion in the work by you, as defined in the Apache-2.0 license, shall be dual licensed as above, without any additional terms or conditions.
